# -*- coding: utf-8 -*-
# import processing
from qgis.core import (edit, QgsVectorLayer)
import datetime
import os
starttime = datetime.datetime.now()
print("Szkript futtatása")

r'''
Szkript leírása:
Egy mappában és annak almappáiban lévő shape fájlokban megvizsgálja, hogy van-e a shape-ben rendelet nevű mező, ha igen, akkor a mező tartalmát frissíti az általunk megadott rendelet szöveggel.
A futtatáshoz két paraméter megadása szükséges:
mappa: shape fájlokat tartalmazó mappa abszolút elérési útja, fontos, hogy ezt a szintaktikát kövessünk: mappa = r"c:\adatok\hesz\shp"
rendelet: rendelet szövege, pl. "12/2010. (X. 13.) önkormányzati rendelet"

'''

# paraméterek megadása
mappa = r"C:\Users\banhidaiandras\Desktop\Uj_telep_sablon_UJ\Uj_telep_sablon"
rendelet = "12/2022 sokadik rendeletszerű bigyóka"


#---------------------------------------------------------------------------
#---------------------------------------------------------------------------
#---------------------------------------------------------------------------


# shapek begyűjtése
shapes = []
for root, dirs, files in os.walk(mappa):
    for f in files:
        if f.lower().endswith('.shp'):
            shapes.append(os.path.join(root, f))

# rendelet mező frissítése
for shp in shapes:   
    layer = QgsVectorLayer(shp, '', 'ogr')
    fields = layer.fields().names()

    if layer.featureCount() != 0:
        for field in fields:
            if 'rendelet' == field.lower():
                print(shp.split("\\")[-1] + ' réteg frissítése')
                features = layer.getFeatures()
                with edit(layer):
                    for feature in features:
                        feature['rendelet'] = rendelet
                        layer.updateFeature(feature)
    del layer


endtime = datetime.datetime.now()
print ("Futtatás sikeres! " + str(endtime-starttime))